import 'dart:async';

import 'package:flutter/services.dart';
import 'package:moyoung_ble_plugin/impl/channel_names.dart';
import 'package:moyoung_ble_plugin/impl/moyoung_beans.dart';

class MYEventStreams {
  Stream<BleScanBean> get bleScanEveStm {
    return const EventChannel(ChannelNames.eventScanDevice)
        .receiveBroadcastStream()
        .map((dynamic event) {
      return bleScanBeanFromJson(event.toString());
    });
  }

  Stream<dynamic> get stateEveStm {
    return const EventChannel(ChannelNames.eventConnectionState)
        .receiveBroadcastStream()
        .map((dynamic event) {
          // print("stateEveStm: $a  ---- $event");
      return event;
    });
  }

  Stream<StepsChangeBean> get stepsChangeEveStm {
    return const EventChannel(ChannelNames.eventStepsChange)
        .receiveBroadcastStream()
        .map((dynamic event) {
      return stepsChangeBeanFromJson(event.toString());
    });
  }

  Stream<DeviceBatteryBean> get deviceBatteryEveStm {
    return const EventChannel(ChannelNames.eventDeviceBattery)
        .receiveBroadcastStream()
        .map((dynamic event) {
      return deviceBatteryBeanFromJson(event);
    });
  }

  Stream<WeatherChangeBean> get weatherChangeEveStm {
    return const EventChannel(ChannelNames.eventWeatherChange)
        .receiveBroadcastStream()
        .map((dynamic event) {
      return weatherChangeBeanFromJson(event);
    });
  }

  Stream<StepsDetailBean> get stepsDetailEveStm {
    return const EventChannel(ChannelNames.eventStepsDetail)
        .receiveBroadcastStream()
        .map((dynamic event) {
      return stepsDetailBeanFromJson(event);
    });
  }

  Stream<SleepBean> get sleepChangeEveStm {
    return const EventChannel(ChannelNames.eventSleepChange)
        .receiveBroadcastStream()
        .map((dynamic event) {
      return sleepBeanFromJson(event);
    });
  }

  Stream<OTABean> get oTAEveStm {
    return const EventChannel(ChannelNames.eventOTA)
        .receiveBroadcastStream()
        .map((dynamic event) {
      return oTABeanFromJson(event);
    });
  }

  Stream<HeartRateBean> get heartRateEveStm {
    return const EventChannel(ChannelNames.eventHeartRate)
        .receiveBroadcastStream()
        .map((dynamic event) {
      return heartRateBeanFromJson(event);
    });
  }

  Stream<BloodPressureBean> get bloodPressureEveStm {
    return const EventChannel(ChannelNames.eventBloodPressure)
        .receiveBroadcastStream()
        .map((dynamic event) {
      return bloodPressureBeanFromJson(event);
    });
  }

  Stream<BloodOxygenBean> get bloodOxygenEveStm {
    return const EventChannel(ChannelNames.eventBloodOxyGen)
        .receiveBroadcastStream()
        .map((dynamic event) {
      return bloodOxygenBeanFromJson(event);
    });
  }

  Stream<String> get cameraEveStm {
    return const EventChannel(ChannelNames.eventBloodOxygen)
        .receiveBroadcastStream()
        .map((dynamic event) {
      return event;
    });
  }

  Stream<int> get phoneEveStm {
    return const EventChannel(ChannelNames.eventPhone)
        .receiveBroadcastStream()
        .map((dynamic event) {
      return event;
    });
  }

  Stream<int> get deviceRssiEveStm {
    return const EventChannel(ChannelNames.eventDeviceRssi)
        .receiveBroadcastStream()
        .map((dynamic event) {
      return event;
    });
  }

  Stream<FileTransBean> get fileTransEveStm {
    return const EventChannel(ChannelNames.eventFileTrans)
        .receiveBroadcastStream()
        .map((dynamic event) {
      return fileTransBeanFromJson(event);
    });
  }

  Stream<FileTransBean> get wfFileTransEveStm {
    return const EventChannel(ChannelNames.eventWFFileTrans)
        .receiveBroadcastStream()
        .map((dynamic event) {
      return fileTransBeanFromJson(event);
    });
  }

  Stream<EcgBean> get ecgEveStm {
    return const EventChannel(ChannelNames.eventEcg)
        .receiveBroadcastStream()
        .map((dynamic event) {
      return ecgBeanFromJson(event);
    });
  }

  Stream<FileTransBean> get tactAvatarEveStm {
    return const EventChannel(ChannelNames.eventContactAvatar)
        .receiveBroadcastStream()
        .map((dynamic event) {
      return fileTransBeanFromJson(event);
    });
  }

  Stream<int> get trainingStateEveStm {
    return const EventChannel(ChannelNames.eventTrainingState)
        .receiveBroadcastStream()
        .map((dynamic event) {
      return event;
    });
  }

  Stream<TempChangeBean> get tempChangeEveStm {
    return const EventChannel(ChannelNames.eventTempChange)
        .receiveBroadcastStream()
        .map((dynamic event) {
      return tempChangeBeanFromJson(event);
    });
  }

  Stream<ContactListenBean> get tactEveStm {
    return const EventChannel(ChannelNames.eventContact)
        .receiveBroadcastStream()
        .map((dynamic event) {
      return contactListenBeanFromJson(event);
    });
  }

  Stream<bool> get batterySavingEveStm {
    return const EventChannel(ChannelNames.eventBatterySaving)
        .receiveBroadcastStream()
        .map((dynamic event) {
      return event;
    });
  }

  Stream<TrainBean> get trainingEveStm {
    return const EventChannel(ChannelNames.eventTrain)
        .receiveBroadcastStream()
        .map((dynamic event) {
      return trainBeanFromJson(event);
    });
  }
}
